----------------------------------------------------------------------------------------------------
--! @file vector_gpio.vhd
--! @brief 
--! @author Antti Lukats
--! @version 1.0
--! @date 2015
--! @license MIT License
--! @copyright Copyright 2015-2016 Trenz Electronic GmbH
--! @pre Vivado 2014.4+
----------------------------------------------------------------------------------------------------
--! Use standard library
library IEEE;
    use IEEE.STD_LOGIC_1164.ALL;


entity vector_gpio is  
	generic (
    --! 
    --! 
    --!         
    C_USE_INMUX    : boolean := false;
    
    C_VECTOR_LSB    : integer range 0 to 255    := 0; --!
    C_VECTOR_WIDTH  : integer range 1 to 256    := 32; --!
    C_GPIO_WIDTH    : integer range 1 to 256    := 32 --!   
    );
    port (
    inmux_sel      : in std_logic_vector(8-1 downto 0) := "00000000";
    inmux_out: out std_logic;
    
    --!
    --! 
    --!
	vector_i      : out std_logic_vector(C_VECTOR_WIDTH-1 downto 0);
    vector_o      : in std_logic_vector(C_VECTOR_WIDTH-1 downto 0) := (others => '0');
    vector_t      : in std_logic_vector(C_VECTOR_WIDTH-1 downto 0) := (others => '1');
    --
	-- 
	--
	gpio_i      : in  std_logic_vector(C_GPIO_WIDTH-1 downto 0);
	gpio_o      : out std_logic_vector(C_GPIO_WIDTH-1 downto 0);
	gpio_t      : out std_logic_vector(C_GPIO_WIDTH-1 downto 0)
	);
	
end vector_gpio;

architecture Behavioral of vector_gpio is

begin
	vector_i 	<= gpio_i;
	gpio_o      <= vector_o;
	gpio_t      <= vector_t;
    
    -- TODO 
    muxin_inst: entity work.asio_widemux 
    generic map (
        C_WIDTH=>C_GPIO_WIDTH,
        C_SEL_BITS=>8) 
    port map (
        din=>gpio_i(C_GPIO_WIDTH-1 downto 0),
        sel=>inmux_sel(8-1 downto 0),
        q => inmux_out);
    
    --inmux_out <= gpio_i(0);

end Behavioral;
